From 26ad0bd98c23c5983c7d13df0ae3ec3b578e9b6c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 18 2020 04:34:16 +0000
Subject: [PATCH 158/2232] Look for end of line when finding headers ifdefs


---

diff --git a/gen/include.rs b/gen/include.rs
index da6678d..68cb00d 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -5,8 +5,8 @@ pub static HEADER: &str = include_str!("include/cxx.h");
 pub fn get(guard: &str) -> &'static str {
     let ifndef = format!("#ifndef {}", guard);
     let endif = format!("#endif // {}", guard);
-    let begin = HEADER.find(&ifndef);
-    let end = HEADER.find(&endif);
+    let begin = find_line(&ifndef);
+    let end = find_line(&endif);
     if let (Some(begin), Some(end)) = (begin, end) {
         &HEADER[begin..end + endif.len()]
     } else {
@@ -14,6 +14,18 @@ pub fn get(guard: &str) -> &'static str {
     }
 }
 
+fn find_line(line: &str) -> Option<usize> {
+    let mut offset = 0;
+    loop {
+        offset += HEADER[offset..].find(line)?;
+        let rest = &HEADER[offset + line.len()..];
+        if rest.starts_with('\n') || rest.starts_with('\r') {
+            return Some(offset);
+        }
+        offset += line.len();
+    }
+}
+
 #[derive(Default)]
 pub struct Includes {
     custom: Vec<String>,

